/**
 ******************************************************************************
 * @file           : main.c
 * @author         : Auto-generated by STM32CubeIDE
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
 * All rights reserved.</center></h2>
 *
 * This software component is licensed by ST under BSD 3-Clause license,
 * the "License"; You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at:
 *                        opensource.org/licenses/BSD-3-Clause
 *
 ******************************************************************************
 */

#include <stdint.h>


#if !defined(__SOFT_FP__) && defined(__ARM_FP)
  #warning "FPU is not initialized, but the project is compiling for an FPU. Please initialize the FPU before use."
#endif

#include<stdio.h>
#include<string.h>

#include "stm32l4r5xxExtd.h"
#include "stm32l4r5xx_gpio.h"
#include "stm32l4r5xx_uart.h"
#include "stm32l4r5xx_decoder.h"
#include "stm32l4r5xx_pwm.h"
#include "common.h"
#include "at_commands.h"
#include "bluetooth.h"

#include "FreeRTOS.h"
#include "task.h"

char msg[50] = "UART Tx testing...\n\r";
char msg1[50] = "Bluetooth Thread..\n\r";

extern USART_Handle_t USART2Handle;
extern USART_Handle_t USART3Handle;


Decoder_Handle_t DEC1;
Decoder_Handle_t DEC2;
Decoder_Handle_t DEC3;


PWM_Handle_t PWM_16;

void delay ( void )
{
	for( uint32_t i =0; i < 20000; i++ );
}



void initLEDButton( void )
{
	GPIO_Handle_t gpioLD2 = {0};
	GPIO_Handle_t gpioLD3 = {0};
	GPIO_Handle_t gpioSW =  {0};

	GPIO_PeriClockControl( GPIOB , ENABLE );
	GPIO_PeriClockControl( GPIOC , ENABLE );

	gpioLD2.pGPIOx = GPIOB;
	gpioLD2.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_7;
	gpioLD2.GPIO_PinfConf.GPIO_OPType = GPIO_OP_TYPE_PP;
	gpioLD2.GPIO_PinfConf.GPIO_PinMode = GPIO_MODE_OUT;
	gpioLD2.GPIO_PinfConf.GPIO_PinSpeed = GPIO_SPEED_HIGH;
	gpioLD2.GPIO_PinfConf.GPIO_PinPuPdControl = GPIO_NO_PUPD;
	GPIO_Init( &gpioLD2 );

	gpioLD3.pGPIOx = GPIOB;
	gpioLD3.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_14;
	gpioLD3.GPIO_PinfConf.GPIO_OPType = GPIO_OP_TYPE_PP;
	gpioLD3.GPIO_PinfConf.GPIO_PinMode = GPIO_MODE_OUT;
	gpioLD3.GPIO_PinfConf.GPIO_PinSpeed = GPIO_SPEED_HIGH;
	gpioLD3.GPIO_PinfConf.GPIO_PinPuPdControl = GPIO_NO_PUPD;
	GPIO_Init( &gpioLD3 );

	// Button
	/*
	gpioSW.pGPIOx = GPIOC;
	gpioSW.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_13;
	gpioSW.GPIO_PinfConf.GPIO_PinMode = GPIO_MODE_IN;
	gpioSW.GPIO_PinfConf.GPIO_PinSpeed = GPIO_SPEED_HIGH;
	gpioSW.GPIO_PinfConf.GPIO_PinPuPdControl = GPIO_NO_PUPD;
	GPIO_Init( &gpioSW );


	gpioSW.pGPIOx = GPIOC;
	gpioSW.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_13;
	gpioSW.GPIO_PinfConf.GPIO_PinMode = GPIO_MODE_IT_RT;
	gpioSW.GPIO_PinfConf.GPIO_PinSpeed = GPIO_SPEED_HIGH;
	gpioSW.GPIO_PinfConf.GPIO_PinPuPdControl = GPIO_NO_PUPD;
	GPIO_Init( &gpioSW );
	GPIO_IRQConfig(EXTI15_10_IRQn, 6, ENABLE);
	*/
	testInitGPIOInterrupt();

}


void USART_GPIOInit( void )
{
	GPIO_Handle_t USART2_gpio = {0};
	GPIO_Handle_t USART3_gpio = {0};

	// USART2 lies over the PORTD, So enable the Port D Peripheral Clock
	GPIO_PeriClockControl( GPIOD , ENABLE );

	USART2_gpio.pGPIOx = GPIOD;
	USART2_gpio.GPIO_PinfConf.GPIO_PinMode = GPIO_MODE_ALTFN;
	USART2_gpio.GPIO_PinfConf.GPIO_OPType = GPIO_OP_TYPE_PP;
	USART2_gpio.GPIO_PinfConf.GPIO_PinPuPdControl = GPIO_PIN_PU;
	USART2_gpio.GPIO_PinfConf.GPIO_PinSpeed = GPIO_SPEED_HIGH;
	USART2_gpio.GPIO_PinfConf.GPIO_PinAlternate = AF7;

	//  USART2_RX : PD6
	USART2_gpio.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_6;
	GPIO_Init( &USART2_gpio );

	//  USART2_TX : PD5
	USART2_gpio.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_5;
	GPIO_Init( &USART2_gpio );

	//-------------------------------------------------
	//	USART3_gpio

	USART3_gpio.GPIO_PinfConf.GPIO_PinMode = GPIO_MODE_ALTFN;
	USART3_gpio.GPIO_PinfConf.GPIO_OPType = GPIO_OP_TYPE_PP;
	USART3_gpio.GPIO_PinfConf.GPIO_PinPuPdControl = GPIO_PIN_PU;
	USART3_gpio.GPIO_PinfConf.GPIO_PinSpeed = GPIO_SPEED_HIGH;
	USART3_gpio.GPIO_PinfConf.GPIO_PinAlternate = AF7;

	//  USART3_RX : PD9
	USART3_gpio.pGPIOx = GPIOD;
	USART3_gpio.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_9;
	GPIO_Init( &USART3_gpio );

	//  USART3_TX : PD8
	USART3_gpio.pGPIOx = GPIOD;
	USART3_gpio.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_8;
	GPIO_Init( &USART3_gpio );

	GPIO_PeriClockControl( GPIOA , ENABLE );
	//  USART3_CTS : PA6
	USART3_gpio.pGPIOx = GPIOA;
	USART3_gpio.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_6;
	GPIO_Init( &USART3_gpio );

	GPIO_PeriClockControl( GPIOB , ENABLE );
	//  USART3_RTS : PB1
	USART3_gpio.pGPIOx = GPIOB;
	USART3_gpio.GPIO_PinfConf.GPIO_PinNumber = GPIO_PIN_1;
	GPIO_Init( &USART3_gpio );

}


void initUSART( void )
{

	USART_GPIOInit();

	USART2Handle.pUSARTx = USART2;
	USART2Handle.USART_Config.USART_Baud = USART_STD_BAUD_9600;
	USART2Handle.USART_Config.USART_HWFlowControl = USART_HW_FLOW_CTRL_NONE;
	USART2Handle.USART_Config.USART_Mode = USART_MODE_TXRX;
	USART2Handle.USART_Config.USART_NumOfStopBits = USART_STOPBITS_1;
	USART2Handle.USART_Config.USART_ParityControl = USART_PARITY_DISABLE;
	USART2Handle.USART_Config.USART_WordLength = USART_WORDLEN_8BITS;

	USART_Init( &USART2Handle );
	USART_PeripheralControl(USART2,ENABLE);
	USART2_IRQConfigEnable();


	// This will create a queue that will send received bytes from USART3 ISR
	USART3_queueInit();


	//BLUETOOTH connection
	USART3Handle.pUSARTx = USART3;
	USART3Handle.USART_Config.USART_Baud = USART_STD_BAUD_19200;
	USART3Handle.USART_Config.USART_HWFlowControl = USART_HW_FLOW_CTRL_CTS_RTS;
	USART3Handle.USART_Config.USART_Mode = USART_MODE_TXRX;
	USART3Handle.USART_Config.USART_NumOfStopBits = USART_STOPBITS_1;
	USART3Handle.USART_Config.USART_ParityControl = USART_PARITY_DISABLE;
	USART3Handle.USART_Config.USART_WordLength = USART_WORDLEN_8BITS;

	USART_Init( &USART3Handle );
	USART_PeripheralControl(USART3,ENABLE);
	USART3_IRQConfigEnable();



}


void initDecoder( void )
{
	/*
	 * There are 3 Encoder monitoring the 3 motors.
	 * Following is the pin config that each of these are connected
	 * Motor1:	EnA: PA5	TIM2_CH1
	 *			EnB: PA1	TIM2_CH2
	 *			EnZ: PA0	TIM2_ETR
	 */
	// Motor1: Timer/ Encoder settings Port A | Timer 2
	DEC1.DecoderBase = TIM2;
	DecoderInit( &DEC1 );


	/*
	 *Motor2:	EnA: PF7	TIM5_CH1
	 *			EnB: PF8	TIM2_CH2
	 *			EnZ: PF6	TIM5_ETR
	 *
	 */
	// Motor2: Timer/ Encoder settings Port F | Timer 5
	DEC2.DecoderBase = TIM5;
	DecoderInit( &DEC2 );


	/*
	 *Motor3: 	EnA: PE3	TIM3_CH1
	 *			EnB: PE4	TIM3_CH2
	 *			EnZ: PE2	TIM3_ETR
	 */
	// Motor3: Timer/ Encoder settings Port E | Timer 3
	DEC3.DecoderBase = TIM3;
	DecoderInit( &DEC3 );

}

void testPWM( void );

void testHelp( void );


void bluetoothTask( void* taskParam )
{
	uint8_t rxData;

	// Reset all the messages/packets received from the Bluetooth UART3 queue
	// This will include the packets that were received while intializing the
	// U-Blox bluetooth module.
	//USART3_queueReset();


	USART_SendData( &USART2Handle, (uint8_t*)msg1, strlen(msg1) );

	while( 1 )
	{

		//rxData = 0;

		manageBLEComm();

		/*if( USART3_BluetoothRx( &rxData ) == true )
		{
			USART_SendData( &USART2Handle, &rxData, 1 );
			// Parse the data received
		}
		*/

	}

}

void bluetoothTask2( void* taskParam )
{

	//testInitGPIOInterrupt();
	while( 1 )
	{
		vTaskDelay( 500 );
		GPIO_TogglePin( GPIOB , GPIO_PIN_14 );
	}

}



int main(void)
{

	initDecoder( );

	initUSART();

	initLEDButton();

	initBluetooth();

	USART_SendData( &USART2Handle, (uint8_t*)msg, strlen(msg) );

	//delay();

	//GPIO_TogglePin( GPIOB , GPIO_PIN_7 );
	// Create task

	xTaskCreate( bluetoothTask, "BluetoothTask", 200 , ( void * ) NULL, 2, NULL );

	xTaskCreate( bluetoothTask2, "BluetoothTask2", 200 , ( void * ) NULL, 2, NULL );

	vTaskStartScheduler();



    /* Loop forever */

	//while(1);

	/*
	while(1)
	{

		if( GPIO_ReadPin( GPIOC, GPIO_PIN_13 ) == GPIO_PIN_SET)
		{
			GPIO_WritePin( GPIOB , GPIO_PIN_7, GPIO_PIN_SET);
			GPIO_WritePin( GPIOB , GPIO_PIN_14, GPIO_PIN_SET);
			//PWMStartTIM16_17( &PWM_16 );
		}
		else
		{
			GPIO_WritePin( GPIOB , GPIO_PIN_7, GPIO_PIN_RESET);
			GPIO_WritePin( GPIOB , GPIO_PIN_14, GPIO_PIN_RESET);
			//PWMStopTIM16_17( &PWM_16 );
		}

		//sendATCommand(AT_COMMAND);
		//delay();
		//GPIO_TogglePin( GPIOB , GPIO_PIN_7 );
		//GPIO_TogglePin( GPIOB , GPIO_PIN_14 );

	}
	*/

}


void testHelp( void )
{
	return;
}



void testPWM( void )
{

	return;
}


